/* examples for the jcifs smb client library in Java
 * Copyright (C) 2001  "Michael B. Allen" <mballen@erols.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import jcifs.smb.SmbFile;
import jcifs.smb.SmbFileOutputStream;
import java.io.FileInputStream;

public class Put {

	public static void main( String argv[] ) throws Exception {

		SmbFile f = new SmbFile( argv[0] );
		FileInputStream in = new FileInputStream( f.getName() );
		SmbFileOutputStream out = new SmbFileOutputStream( f );

		long t0 = System.currentTimeMillis();

		byte[] b = new byte[65535];
		int n, tot = 0;
		while(( n = in.read( b )) > 0 ) {
			out.write( b, 0, n );
			tot += n;
			System.out.print( '#' );
		}

		long t = System.currentTimeMillis() - t0;

		System.out.println();
		System.out.println( tot + " bytes transfered in " + ( t / 1000 ) + " seconds at " + (( tot / 1000 ) / Math.max( 1, ( t / 1000 ))) + "Kbytes/sec" );

		in.close();
		out.close();
	}
}
