/* jcifs smb client library in Java
 * Copyright (C) 2000  "Michael B. Allen" <mballen@erols.com>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jcifs.smb;

import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;
import java.io.IOException;
import java.net.MalformedURLException;

public class Handler extends URLStreamHandler {

	SmbURL url;

	public URLConnection openConnection( URL u ) throws IOException {
		return new SmbURLConnection( u, url );
	}
	protected void parseURL( URL u, String spec, int start, int limit ) {
		try {
			url = new SmbURL( spec, null, start, limit );
		} catch( MalformedURLException mue ) {
			Log.printStackTrace( "smb URL Handler exception", mue );
		}
		setURL( u, "smb", url.host, url.port, url.canonicalPath, null );
	}
	protected String toExternalForm( URL u ) {
		return url.toString();
	}
}
