/* jcifs smb client library in Java
 * Copyright (C) 2000  "Michael B. Allen" <mballen@erols.com>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jcifs.smb;

class SmbComReadAndX extends AndXServerMessageBlock {

	int fid,
		offset,
		maxCount;

	SmbComReadAndX( int fid, int offset, int maxCount, ServerMessageBlock andx ) {
		super( andx );
		this.fid = fid;
		this.offset = offset;
		this.maxCount = maxCount;
		command = SMB_COM_READ_ANDX;
	}

	int writeParameterWordsWireFormat( byte[] dst, int dstIndex ) {
		int start = dstIndex;

		writeInt2( fid, dst, dstIndex );
		dstIndex += 2;
		writeInt4( offset, dst, dstIndex );
		dstIndex += 4;
		writeInt2( maxCount, dst, dstIndex );
		dstIndex += 2;
		for( int i = 0; i < 8; i++ ) {
			dst[dstIndex++] = (byte)0x00;
		}

		return dstIndex - start;
	}
	int writeBytesWireFormat( byte[] dst, int dstIndex ) {
		return 0;
	}
	int readParameterWordsWireFormat( byte[] buffer, int bufferIndex ) {
		return 0;
	}
	int readBytesWireFormat( byte[] buffer, int bufferIndex ) {
		return 0;
	}
	public String toString() {
		return new String( "SmbComReadAndX[" +
			super.toString() +
			",fid=" + fid +
			",offset=" + offset +
			",maxCount=" + maxCount + "]" );
	}
}
