/* jcifs smb client library in Java
 * Copyright (C) 2000  "Michael B. Allen" <mballen@erols.com>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jcifs.smb;

class SmbComSessionSetupAndXResponse extends AndXServerMessageBlock {

	boolean isLoggedInAsGuest;
	String nativeOs = "";
	String nativeLanMan = "";
	String primaryDomain = "";

	SmbComSessionSetupAndXResponse() {
	}

	int writeParameterWordsWireFormat( byte[] dst, int dstIndex ) {
		return 0;
	}
	int writeBytesWireFormat( byte[] dst, int dstIndex ) {
		return 0;
	}
	int readParameterWordsWireFormat( byte[] buffer, int bufferIndex ) {
		isLoggedInAsGuest = ( buffer[bufferIndex] & 0x01 ) == 0x01 ? true : false;
		return 2;
	}
	int readBytesWireFormat( byte[] buffer, int bufferIndex ) {
		if( byteCount == 0 ) {
			return 0;
		}
		int start = bufferIndex;
		int l;

		if( buffer[bufferIndex] == 0x00 ) {
			bufferIndex++; // NT 4 with Unicode has a 0 here?
		}
		nativeOs = readString( buffer, bufferIndex );
		bufferIndex += stringWireLength( nativeOs );
		nativeLanMan = readString( buffer, bufferIndex );
		bufferIndex += stringWireLength( nativeLanMan );
		primaryDomain = readString( buffer, bufferIndex );
		bufferIndex += stringWireLength( primaryDomain );

		return bufferIndex - start;
	}
	public String toString() {
		String result = new String( "SmbComSessionSetupAndXResponse[" +
			super.toString() +
			",isLoggedInAsGuest=" + isLoggedInAsGuest +
			",nativeOs=" + nativeOs +
			",nativeLanMan=" + nativeLanMan +
			",primaryDomain=" + primaryDomain + "]" );
		return result;
	}
}

