/* jcifs smb client library in Java
 * Copyright (C) 2000  "Michael B. Allen" <mballen@erols.com>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jcifs.smb;

import jcifs.util.Config;

class Trans2FindNext2 extends SmbComTransaction {

	int sid, searchCount, informationLevel, resumeKey, flags;
	String filename;

	Trans2FindNext2( int sid, String filename ) {
		subCommand = TRANS2_FIND_NEXT2;
		this.sid = sid;
		searchCount = 6;
		informationLevel = Trans2FindFirst2.SMB_FILE_BOTH_DIRECTORY_INFO;
		resumeKey = 0x0000;
		flags = 0x00;
		this.filename = filename;
		totalDataCount = 0;
		maxParameterCount = 8;
		maxDataCount = Config.getInt( "jcifs.smb.client.listSize",
									Trans2FindFirst2.DEFAULT_MAX_DATA_COUNT );
		maxSetupCount = 0;
	}

	public Object nextElement() {
		totalParameterCount = 12 + stringWireLength( filename );
		return super.nextElement();
	}
	int writeParametersWireFormat( byte[] dst, int dstIndex, int len ) {
		int start = dstIndex;

		writeInt2( sid, dst, dstIndex );
		dstIndex += 2;
		writeInt2( searchCount, dst, dstIndex );
		dstIndex += 2;
		writeInt2( informationLevel, dst, dstIndex );
		dstIndex += 2;
		writeInt4( resumeKey, dst, dstIndex );
		dstIndex += 4;
		writeInt2( flags, dst, dstIndex );
		dstIndex += 2;
		dstIndex += writeString( filename, dst, dstIndex );

		return dstIndex - start;
	}
	int writeDataWireFormat( byte[] dst, int dstIndex, int len ) {
		return 0;
	}
	int readParametersWireFormat( byte[] buffer, int bufferIndex ) {
		return 0;
	}
	int readDataWireFormat( byte[] buffer, int bufferIndex ) {
		return 0;
	}
	public String toString() {
		return new String( "Trans2FindNext2[" + super.toString() +
			",sid=" + sid +
			",searchCount=" + searchCount +
			",informationLevel=0x" + Log.getHexString( informationLevel, 3 ) +
			",resumeKey=0x" + Log.getHexString( resumeKey, 4 ) +
			",flags=0x" + Log.getHexString( flags, 2 ) +
			",filename=" + filename + "]" );
	}
}
