/* jcifs smb client library in Java
 * Copyright (C) 2000  "Michael B. Allen" <mballen@erols.com>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jcifs.smb;

class Trans2QueryPathInformation extends SmbComTransaction {

	int informationLevel;
	String filename;

	Trans2QueryPathInformation( String filename, int informationLevel ) {
		this.filename = filename;
		this.informationLevel = informationLevel;
		subCommand = TRANS2_QUERY_PATH_INFORMATION;
		totalDataCount = 0;
		maxParameterCount = 2;
		maxDataCount = 40;
		maxSetupCount = (byte)0x00;
	}

	public Object nextElement() {
		totalParameterCount = 6 + stringWireLength( filename );
		return super.nextElement();
	}
	int writeParametersWireFormat( byte[] dst, int dstIndex, int len ) {
		int start = dstIndex;

		writeInt2( informationLevel, dst, dstIndex );
		dstIndex += 2;
		dst[dstIndex++] = (byte)0x00;
		dst[dstIndex++] = (byte)0x00;
		dst[dstIndex++] = (byte)0x00;
		dst[dstIndex++] = (byte)0x00;
		dstIndex += writeString( filename, dst, dstIndex );

		return dstIndex - start;
	}
	int writeDataWireFormat( byte[] dst, int dstIndex, int len ) {
		return 0;
	}
	int readParametersWireFormat( byte[] buffer, int bufferIndex ) {
		return 0;
	}
	int readDataWireFormat( byte[] buffer, int bufferIndex ) {
		return 0;
	}
	public String toString() {
		return new String( "Trans2QueryPathInformation[" + super.toString() +
			",informationLevel=0x" + Log.getHexString( informationLevel, 3 ) +
			",filename=" + filename + "]" );
	}
}
